"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputOperationPipe = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
const zod_validation_error_1 = require("zod-validation-error");
const zod_1 = require("zod");
const constants_1 = require("../constants");
class InputOperationPipe {
    zodInputOperation;
    transform(value) {
        try {
            return this.zodInputOperation.parse(value, {
                errorMap: zod_validation_error_1.errorMap,
            })[json_api_nestjs_shared_1.KEY_MAIN_INPUT_SCHEMA];
        }
        catch (e) {
            if (e instanceof zod_1.ZodError) {
                throw new common_1.BadRequestException(e.issues);
            }
            throw new common_1.InternalServerErrorException(e);
        }
    }
}
exports.InputOperationPipe = InputOperationPipe;
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.ZOD_INPUT_OPERATION),
    tslib_1.__metadata("design:type", Object)
], InputOperationPipe.prototype, "zodInputOperation", void 0);
//# sourceMappingURL=input-operation.pipe.js.map