"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZodInputPatchRelationshipSchema = exports.ZodInputPostRelationshipSchema = void 0;
exports.ZodInputQuerySchema = ZodInputQuerySchema;
exports.ZodQuerySchema = ZodQuerySchema;
exports.ZodPostSchema = ZodPostSchema;
exports.ZodPatchSchema = ZodPatchSchema;
const zod_1 = require("../zod");
const constants_1 = require("../../../constants");
const service_1 = require("../service");
function ZodInputQuerySchema() {
    return {
        provide: constants_1.ZOD_INPUT_QUERY_SCHEMA,
        inject: [service_1.EntityParamMapService],
        useFactory: (entityParamMapService) => {
            return (0, zod_1.zodInputQuery)(entityParamMapService);
        },
    };
}
function ZodQuerySchema() {
    return {
        provide: constants_1.ZOD_QUERY_SCHEMA,
        inject: [service_1.EntityParamMapService],
        useFactory: (entityParamMapService) => {
            return (0, zod_1.zodQuery)(entityParamMapService);
        },
    };
}
function ZodPostSchema() {
    return {
        provide: constants_1.ZOD_POST_SCHEMA,
        inject: [service_1.EntityParamMapService],
        useFactory: (entityParamMapService) => {
            return (0, zod_1.zodPost)(entityParamMapService);
        },
    };
}
function ZodPatchSchema() {
    return {
        provide: constants_1.ZOD_PATCH_SCHEMA,
        inject: [service_1.EntityParamMapService],
        useFactory: (entityParamMapService) => {
            return (0, zod_1.zodPatch)(entityParamMapService);
        },
    };
}
exports.ZodInputPostRelationshipSchema = {
    provide: constants_1.ZOD_POST_RELATIONSHIP_SCHEMA,
    useValue: zod_1.zodPostRelationship,
};
exports.ZodInputPatchRelationshipSchema = {
    provide: constants_1.ZOD_PATCH_RELATIONSHIP_SCHEMA,
    useValue: zod_1.zodPatchRelationship,
};
//# sourceMappingURL=zod-validate.factory.js.map