"use strict";
var LogTimeInterceptors_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogTimeInterceptors = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
let LogTimeInterceptors = class LogTimeInterceptors {
    static { LogTimeInterceptors_1 = this; }
    static _instance;
    constructor() {
        if (LogTimeInterceptors_1._instance) {
            return LogTimeInterceptors_1._instance;
        }
        LogTimeInterceptors_1._instance = this;
    }
    intercept(context, next) {
        const now = performance.now();
        return next.handle().pipe((0, rxjs_1.map)((r) => {
            const response = context.switchToHttp().getResponse();
            const time = performance.now() - now;
            response.setHeader('x-response-time', time);
            if (r && r.meta) {
                r.meta['time'] = time;
            }
            return r;
        }));
    }
};
exports.LogTimeInterceptors = LogTimeInterceptors;
exports.LogTimeInterceptors = LogTimeInterceptors = LogTimeInterceptors_1 = tslib_1.__decorate([
    (0, common_1.Injectable)(),
    tslib_1.__metadata("design:paramtypes", [])
], LogTimeInterceptors);
//# sourceMappingURL=log-time.interceptors.js.map