"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryPipe = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const zod_1 = require("zod");
const constants_1 = require("../../../../constants");
class QueryPipe {
    zodQuerySchema;
    transform(value) {
        try {
            return this.zodQuerySchema.parse(value);
        }
        catch (e) {
            if (e instanceof zod_1.ZodError) {
                throw new common_1.BadRequestException(e.issues);
            }
            throw new common_1.InternalServerErrorException(e);
        }
    }
}
exports.QueryPipe = QueryPipe;
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.ZOD_QUERY_SCHEMA),
    tslib_1.__metadata("design:type", Object)
], QueryPipe.prototype, "zodQuerySchema", void 0);
//# sourceMappingURL=query.pipe.js.map