"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorFormatService = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const constants_1 = require("../../../constants");
let ErrorFormatService = class ErrorFormatService {
    config;
    defaultErrorMsg = 'Internal Server Error';
    formatError(error) {
        if (error instanceof common_1.HttpException) {
            return error;
        }
        const errMessage = error instanceof Error
            ? this.config.options.debug
                ? error.message
                : this.defaultErrorMsg
            : this.defaultErrorMsg;
        const errorObject = {
            code: 'internal_error',
            message: errMessage,
            path: [],
        };
        const descriptionOrOptions = this.config.options.debug
            ? {
                description: this.defaultErrorMsg,
                cause: error instanceof Error ? error : undefined,
            }
            : {
                description: this.defaultErrorMsg,
            };
        return new common_1.InternalServerErrorException([errorObject], descriptionOrOptions);
    }
};
exports.ErrorFormatService = ErrorFormatService;
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.MODULE_OPTIONS_TOKEN),
    tslib_1.__metadata("design:type", Object)
], ErrorFormatService.prototype, "config", void 0);
exports.ErrorFormatService = ErrorFormatService = tslib_1.__decorate([
    (0, common_1.Injectable)()
], ErrorFormatService);
//# sourceMappingURL=error-format.service.js.map