import { Attributes, Include, PropertyKeys, Relationships, ResourceData, ResourceObject, BaseMainData, RelationKeys } from '@klerick/json-api-nestjs-shared';
import { EntityParam } from '../../../types';
import { Query, QueryOne } from '../zod';
export declare class JsonApiTransformerService<E extends object, IdKey extends string = 'id'> {
    private applicationConfig;
    private entityParamMapService;
    private _urlPath;
    get currentMapProps(): EntityParam<E, IdKey>;
    get urlPath(): string[];
    transformData(data: E, query: QueryOne<E, IdKey>): Pick<ResourceObject<E, 'object', null, IdKey>, 'data' | 'included'>;
    transformData(data: E[], query: Query<E, IdKey>): Pick<ResourceObject<E, 'array', null, IdKey>, 'data' | 'included'>;
    transformItem<T extends object = E, TIdKey extends string = IdKey>(item: T, mapProps: EntityParam<T, TIdKey>, query: Query<T, TIdKey>): ResourceData<T, TIdKey>;
    transformRel<Rel extends RelationKeys<E, IdKey>>(item: E, rel: Rel): BaseMainData<E, IdKey, Rel>['data'];
    transformRelationships<T extends object = E, TIdKey extends string = IdKey>(item: T, mapProps: EntityParam<T, TIdKey>, query: Query<T, TIdKey>): Relationships<T, TIdKey>;
    extractAttributes<T extends object = E, TIdKey extends string = IdKey>(item: T, fields: PropertyKeys<T, TIdKey>[]): Attributes<T, TIdKey>;
    extractIncluded<T extends object = E, TIdKey extends string = IdKey>(data: T[], query: Query<E, IdKey>): Include<T, TIdKey>[];
    private getLink;
}
