"use strict";
var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterOperand = exports.OperandsMapTitle = void 0;
const tslib_1 = require("tslib");
const swagger_1 = require("@nestjs/swagger");
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
const title = 'is equal to the conditional of query';
exports.OperandsMapTitle = {
    [json_api_nestjs_shared_1.FilterOperand.in]: `${title} "WHERE 'attribute_name' IN ('value1', 'value2')"`,
    [json_api_nestjs_shared_1.FilterOperand.nin]: `${title} "WHERE 'attribute_name' NOT IN ('value1', 'value1')"`,
    [json_api_nestjs_shared_1.FilterOperand.eq]: `${title} "WHERE 'attribute_name' = 'value1'`,
    [json_api_nestjs_shared_1.FilterOperand.ne]: `${title} "WHERE 'attribute_name' <> 'value1'`,
    [json_api_nestjs_shared_1.FilterOperand.gt]: `${title} "WHERE 'attribute_name' > 'value1'`,
    [json_api_nestjs_shared_1.FilterOperand.gte]: `${title} "WHERE 'attribute_name' >= 'value1'`,
    [json_api_nestjs_shared_1.FilterOperand.like]: `${title} "WHERE 'attribute_name' ILIKE %value1%`,
    [json_api_nestjs_shared_1.FilterOperand.lt]: `${title} "WHERE 'attribute_name' < 'value1'`,
    [json_api_nestjs_shared_1.FilterOperand.lte]: `${title} "WHERE 'attribute_name' <= 'value1'`,
    [json_api_nestjs_shared_1.FilterOperand.regexp]: `${title} "WHERE 'attribute_name' ~* value1`,
    [json_api_nestjs_shared_1.FilterOperand.some]: `${title} "WHERE 'attribute_name' && [value1]`,
};
class FilterOperand {
    [_a = json_api_nestjs_shared_1.FilterOperand.in];
    [_b = json_api_nestjs_shared_1.FilterOperand.nin];
    [_c = json_api_nestjs_shared_1.FilterOperand.eq];
    [_d = json_api_nestjs_shared_1.FilterOperand.ne];
    [_e = json_api_nestjs_shared_1.FilterOperand.gte];
    [_f = json_api_nestjs_shared_1.FilterOperand.gt];
    [_g = json_api_nestjs_shared_1.FilterOperand.lt];
    [_h = json_api_nestjs_shared_1.FilterOperand.lte];
    [_j = json_api_nestjs_shared_1.FilterOperand.regexp];
    [_k = json_api_nestjs_shared_1.FilterOperand.some];
}
exports.FilterOperand = FilterOperand;
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.in],
        required: false,
        type: 'array',
        items: {
            type: 'string',
        },
    }),
    tslib_1.__metadata("design:type", Array)
], FilterOperand.prototype, _a, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.nin],
        required: false,
        type: 'array',
        items: {
            type: 'string',
        },
    }),
    tslib_1.__metadata("design:type", Array)
], FilterOperand.prototype, _b, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.eq],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _c, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.ne],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _d, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.gte],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _e, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.gt],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _f, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.lt],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _g, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.lte],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _h, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.regexp],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _j, void 0);
tslib_1.__decorate([
    (0, swagger_1.ApiProperty)({
        title: exports.OperandsMapTitle[json_api_nestjs_shared_1.FilterOperand.some],
        required: false,
    }),
    tslib_1.__metadata("design:type", String)
], FilterOperand.prototype, _k, void 0);
//# sourceMappingURL=filter-operand-model.js.map