import { z, ZodObject, ZodOptional } from 'zod';
import { ZodAttributes, ZodId, ZodRelationships, ZodType } from '../zod-share';
import { EntityParamMapService } from '../../service';
type ZodPatchPatchShape<E extends object, IdKey extends string> = {
    id: ZodId;
    type: ZodType<string>;
    attributes: ZodOptional<ZodAttributes<E, IdKey, true>>;
    relationships: ZodOptional<ZodRelationships<E, IdKey, true>>;
};
type ZodInputPatchSchema<E extends object, IdKey extends string> = ZodObject<ZodPatchPatchShape<E, IdKey>, 'strict'>;
type ZodInputPatchDataShape<E extends object, IdKey extends string> = {
    data: ZodInputPatchSchema<E, IdKey>;
};
export declare function zodPatch<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): ZodPatch<E, IdKey>;
export type ZodPatch<E extends object, IdKey extends string> = ZodObject<ZodInputPatchDataShape<E, IdKey>, 'strict'>;
export type PatchData<E extends object, IdKey extends string> = z.infer<ZodPatch<E, IdKey>>['data'];
export {};
