"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodPost = zodPost;
const zod_1 = require("zod");
const zod_share_1 = require("../zod-share");
function getShape(entityParamMapService) {
    const shape = {
        id: (0, zod_share_1.zodId)(entityParamMapService.entityParaMap.primaryColumnType).optional(),
        type: (0, zod_share_1.zodType)(entityParamMapService.entityParaMap.typeName),
        attributes: (0, zod_share_1.zodAttributes)(entityParamMapService, false),
        relationships: (0, zod_share_1.zodRelationships)(entityParamMapService, false).optional(),
    };
    return zod_1.z.object(shape).strict();
}
function zodDataShape(shape) {
    return zod_1.z
        .object({
        data: shape,
    })
        .strict();
}
function zodPost(entityParamMapService) {
    const shape = getShape(entityParamMapService);
    return zodDataShape(shape);
}
//# sourceMappingURL=index.js.map