import { FilterOperand } from '@klerick/json-api-nestjs-shared';
import { z, ZodType } from 'zod';
import { EntityParamMapService } from '../../service';
import { EntityParam, EntityRelationProps, UnionToTuple } from '../../../../types';
type FilterType = Partial<{
    [key in FilterOperand]: string | string[];
}>;
type OutPutFilter = {
    relation: null | Record<string, Record<string, FilterType>>;
    target: null | Record<string, FilterType>;
};
declare function getZodRulesForFilterOperator(): z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>;
export type ZodRulesForFilterOperator = ReturnType<typeof getZodRulesForFilterOperator>;
export type ConcatRelationField<E extends object, IdKey extends string> = UnionToTuple<{
    [K in keyof EntityRelationProps<E, IdKey>]: `${K & string}.${EntityRelationProps<E, IdKey>[K][number] & string}`;
}[keyof EntityRelationProps<E, IdKey>]>;
export type ShapeArrayInput<E extends object, IdKey extends string> = EntityParam<E, IdKey>['props'] | EntityParam<E, IdKey>['relations'] | ConcatRelationField<E, IdKey>;
export declare function shapeForArray<E extends object, Z extends ZodType, IdKey extends string, PropsList extends ShapeArrayInput<E, IdKey>>(fields: PropsList, zodSchema: Z): { [K in PropsList[number] & PropertyKey]: Z; };
export declare function zodFilterInputQuery<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): z.ZodEffects<z.ZodOptional<z.ZodObject<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in UnionToTuple<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, import("ts-toolbelt/out/Union/Last").Last<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>>, [Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">], import("ts-toolbelt/out/Union/Last").Last<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]>, [{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }>, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in UnionToTuple<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, import("ts-toolbelt/out/Union/Last").Last<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>>, [Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">], import("ts-toolbelt/out/Union/Last").Last<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]>, [{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in UnionToTuple<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, import("ts-toolbelt/out/Union/Last").Last<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>>, [Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">], import("ts-toolbelt/out/Union/Last").Last<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]>, [{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }>>, any>[k]; } : never, z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in UnionToTuple<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, import("ts-toolbelt/out/Union/Last").Last<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>>, [Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">], import("ts-toolbelt/out/Union/Last").Last<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]>, [{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in UnionToTuple<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, import("ts-toolbelt/out/Union/Last").Last<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>>, [Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">], import("ts-toolbelt/out/Union/Last").Last<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]>, [{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }>>[k_1]; } : never>>, OutPutFilter, (z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in UnionToTuple<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, import("ts-toolbelt/out/Union/Last").Last<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>>, [Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">], import("ts-toolbelt/out/Union/Last").Last<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]>, [{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }>> extends infer T_2 ? { [k_1 in keyof T_2]: z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in UnionToTuple<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, import("ts-toolbelt/out/Union/Last").Last<Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>>, [Exclude<keyof E, import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">], import("ts-toolbelt/out/Union/Last").Last<{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]>, [{ [K_2 in keyof EntityRelationProps<E, IdKey>]: `${K_2 & string}.${EntityRelationProps<E, IdKey>[K_2][number] & string}`; }[import("@klerick/json-api-nestjs-shared").RelationKeys<E, "id">]] extends [never] ? true : false>[number] & PropertyKey]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>, {
    some?: string | undefined;
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
}, {
    some?: string | number | null | undefined;
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
}>]>>; }>>[k_1]; } : never) | undefined>;
export type ZodFilterInputQuery<E extends object, IdKey extends string> = z.infer<ReturnType<typeof zodFilterInputQuery<E, IdKey>>>;
export {};
