"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodInputQuery = zodInputQuery;
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
const zod_1 = require("zod");
const fields_1 = require("./fields");
const filter_1 = require("./filter");
const include_1 = require("./include");
const sort_1 = require("./sort");
const zod_share_1 = require("../zod-share");
function zodInputQuery(entityParamMapService) {
    return zod_1.z
        .object({
        [json_api_nestjs_shared_1.QueryField.fields]: (0, fields_1.zodFieldsInputQuery)(entityParamMapService),
        [json_api_nestjs_shared_1.QueryField.filter]: (0, filter_1.zodFilterInputQuery)(entityParamMapService),
        [json_api_nestjs_shared_1.QueryField.include]: (0, include_1.zodIncludeInputQuery)(),
        [json_api_nestjs_shared_1.QueryField.sort]: (0, sort_1.zodSortInputQuery)(),
        [json_api_nestjs_shared_1.QueryField.page]: (0, zod_share_1.zodPageInputQuery)(),
    })
        .strict(`Query object should contain only allow params: "${Object.keys(json_api_nestjs_shared_1.QueryField).join('"."')}"`);
}
//# sourceMappingURL=index.js.map