import { z, ZodOptional } from 'zod';
import { EntityParamMapService } from '../../service';
import { EntityParam, TypeField, TypeOfConstructor } from '../../../../types';
declare const zodRuleForArrayField: z.ZodObject<{
    some: z.ZodEffects<z.ZodArray<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>, "atleastone">, [string | null, ...(string | null)[]], [string, ...string[]]>;
}, "strict", z.ZodTypeAny, {
    some: [string | null, ...(string | null)[]];
}, {
    some: [string, ...string[]];
}>;
declare const zodRuleFilterRelationSchema: z.ZodUnion<[z.ZodObject<{
    eq: z.ZodUnion<[z.ZodLiteral<"null">, z.ZodEffects<z.ZodLiteral<null>, "null", null>]>;
}, "strict", z.ZodTypeAny, {
    eq: "null";
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodUnion<[z.ZodLiteral<"null">, z.ZodEffects<z.ZodLiteral<null>, "null", null>]>;
}, "strict", z.ZodTypeAny, {
    ne: "null";
}, {
    ne: "null" | null;
}>]>;
declare function getZodRulesForField(type?: TypeField): z.ZodEffects<z.ZodObject<{
    in: z.ZodOptional<z.ZodEffects<z.ZodArray<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>, "atleastone">, [string | null, ...(string | null)[]], [string, ...string[]]>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodArray<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>, "atleastone">, [string | null, ...(string | null)[]], [string, ...string[]]>>;
    eq: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    gt: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    gte: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    like: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    lt: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    lte: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    ne: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    regexp: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | null | undefined;
    gt?: string | null | undefined;
    gte?: string | null | undefined;
    like?: string | null | undefined;
    lt?: string | null | undefined;
    lte?: string | null | undefined;
    ne?: string | null | undefined;
    regexp?: string | null | undefined;
    in?: [string | null, ...(string | null)[]] | undefined;
    nin?: [string | null, ...(string | null)[]] | undefined;
}, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: [string, ...string[]] | undefined;
    nin?: [string, ...string[]] | undefined;
}>, {
    eq?: string | null | undefined;
    gt?: string | null | undefined;
    gte?: string | null | undefined;
    like?: string | null | undefined;
    lt?: string | null | undefined;
    lte?: string | null | undefined;
    ne?: string | null | undefined;
    regexp?: string | null | undefined;
    in?: [string | null, ...(string | null)[]] | undefined;
    nin?: [string | null, ...(string | null)[]] | undefined;
}, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: [string, ...string[]] | undefined;
    nin?: [string, ...string[]] | undefined;
}>;
declare function getZodRulesForRelationShape<E extends object, IdKey extends string>(shape: FilterProps<E, IdKey>): z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, IdKey>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, IdKey>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, IdKey>>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, IdKey>> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<FilterProps<E, IdKey>>[k_1]; } : never) | undefined>;
type ZodRuleForArrayField = typeof zodRuleForArrayField;
type ZodRuleFilterRelationSchema = typeof zodRuleFilterRelationSchema;
type ZodRulesForField = ReturnType<typeof getZodRulesForField>;
type ZodRulesForRelationShape<E extends object, IdKey extends string> = ReturnType<typeof getZodRulesForRelationShape<E, IdKey>>;
type RelTypeBase<E extends object, IdKey extends string, Rel extends keyof EntityParam<E, IdKey>['relationProperty']> = TypeOfConstructor<EntityParam<E, IdKey>['relationProperty'][Rel]['entityClass']>;
type RelType<E extends object, IdKey extends string, Rel extends keyof EntityParam<E, IdKey>['relationProperty']> = RelTypeBase<E, IdKey, Rel> extends object ? RelTypeBase<E, IdKey, Rel> : never;
type RelationFilterProps<E extends object, IdKey extends string> = {
    [R in keyof EntityParam<E, IdKey>['relationProperty']]: ZodRulesForRelationShape<RelType<E, IdKey, R>, IdKey>;
};
export type FilterProps<E extends object, IdKey extends string> = {
    [Props in EntityParam<E, IdKey>['props'][number] & PropertyKey]: Props extends keyof E ? E[Props] extends TypeField.array ? ZodOptional<ZodRuleForArrayField> : ZodOptional<ZodRulesForField> : never;
};
type TargetRelationShape<E extends object, IdKey extends string> = {
    [Props in EntityParam<E, IdKey>['relations'][number] & PropertyKey]: ZodOptional<ZodRuleFilterRelationSchema>;
};
type ResultTargetType<E extends object, IdKey extends string> = FilterProps<E, IdKey> & TargetRelationShape<E, IdKey>;
export declare function zodFilterQuery<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): z.ZodEffects<z.ZodObject<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_4 ? { [k_2 in keyof T_4]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_5 ? { [k_3 in keyof T_5]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_6 ? { [k_2 in keyof T_6]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_7 ? { [k_3 in keyof T_7]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_17 ? { [k in keyof T_17]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_18 ? { [k_1 in keyof T_18]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_19 ? { [k in keyof T_19]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_20 ? { [k_1 in keyof T_20]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_21 ? { [k_2 in keyof T_21]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_22 ? { [k_3 in keyof T_22]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_23 ? { [k_2 in keyof T_23]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_24 ? { [k_3 in keyof T_24]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}>, any> extends infer T_8 ? { [k_4 in keyof T_8]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_9 ? { [k in keyof T_9]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_10 ? { [k_1 in keyof T_10]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_11 ? { [k in keyof T_11]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_12 ? { [k_1 in keyof T_12]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_13 ? { [k_2 in keyof T_13]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_14 ? { [k_3 in keyof T_14]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_15 ? { [k_2 in keyof T_15]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_16 ? { [k_3 in keyof T_16]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}>, any>[k_4]; } : never, z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_34 ? { [k in keyof T_34]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_35 ? { [k_1 in keyof T_35]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_36 ? { [k in keyof T_36]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_37 ? { [k_1 in keyof T_37]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_38 ? { [k_2 in keyof T_38]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_39 ? { [k_3 in keyof T_39]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_40 ? { [k_2 in keyof T_40]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_41 ? { [k_3 in keyof T_41]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}> extends infer T_25 ? { [k_5 in keyof T_25]: z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_26 ? { [k in keyof T_26]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_27 ? { [k_1 in keyof T_27]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_28 ? { [k in keyof T_28]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_29 ? { [k_1 in keyof T_29]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_30 ? { [k_2 in keyof T_30]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_31 ? { [k_3 in keyof T_31]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_32 ? { [k_2 in keyof T_32]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_33 ? { [k_3 in keyof T_33]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}>[k_5]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_51 ? { [k in keyof T_51]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_52 ? { [k_1 in keyof T_52]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_53 ? { [k in keyof T_53]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_54 ? { [k_1 in keyof T_54]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_55 ? { [k_2 in keyof T_55]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_56 ? { [k_3 in keyof T_56]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_57 ? { [k_2 in keyof T_57]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_58 ? { [k_3 in keyof T_58]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}>, any> extends infer T_42 ? { [k_4 in keyof T_42]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_43 ? { [k in keyof T_43]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_44 ? { [k_1 in keyof T_44]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_45 ? { [k in keyof T_45]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_46 ? { [k_1 in keyof T_46]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_47 ? { [k_2 in keyof T_47]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_48 ? { [k_3 in keyof T_48]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_49 ? { [k_2 in keyof T_49]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_50 ? { [k_3 in keyof T_50]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}>, any>[k_4]; } : never, z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_68 ? { [k in keyof T_68]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_69 ? { [k_1 in keyof T_69]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_70 ? { [k in keyof T_70]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_71 ? { [k_1 in keyof T_71]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_72 ? { [k_2 in keyof T_72]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_73 ? { [k_3 in keyof T_73]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_74 ? { [k_2 in keyof T_74]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_75 ? { [k_3 in keyof T_75]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}> extends infer T_59 ? { [k_5 in keyof T_59]: z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<ResultTargetType<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_60 ? { [k in keyof T_60]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never, z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_61 ? { [k_1 in keyof T_61]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any> extends infer T_62 ? { [k in keyof T_62]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ResultTargetType<E, IdKey>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<ResultTargetType<E, IdKey>> extends infer T_63 ? { [k_1 in keyof T_63]: z.baseObjectInputType<ResultTargetType<E, IdKey>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E, IdKey>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_64 ? { [k_2 in keyof T_64]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_65 ? { [k_3 in keyof T_65]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any> extends infer T_66 ? { [k_2 in keyof T_66]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E, IdKey>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E, IdKey>> extends infer T_67 ? { [k_3 in keyof T_67]: z.baseObjectInputType<RelationFilterProps<E, IdKey>>[k_3]; } : never) | undefined>>;
}>[k_5]; } : never>;
export type ZodFilterQuery<E extends object, IdKey extends string> = ReturnType<typeof zodFilterQuery<E, IdKey>>;
export type FilterQuery<E extends object, IdKey extends string> = z.infer<ZodFilterQuery<E, IdKey>>;
export {};
