"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodIncludeQuery = zodIncludeQuery;
const zod_1 = require("zod");
const zod_utils_1 = require("../zod-utils");
function zodIncludeQuery(entityParamMapService) {
    const relationProps = entityParamMapService.entityParaMap.relations;
    return zod_1.z
        .enum(relationProps)
        .array()
        .nonempty()
        .refine((0, zod_utils_1.uniqueArray)(), {
        message: 'Include should have unique relation',
    })
        .nullable();
}
//# sourceMappingURL=include.js.map