"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodQuery = zodQuery;
const zod_1 = require("zod");
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
const fields_1 = require("./fields");
const filter_1 = require("./filter");
const include_1 = require("./include");
const sort_1 = require("./sort");
const zod_share_1 = require("../zod-share");
function getShape(entityParamMapService) {
    return {
        [json_api_nestjs_shared_1.QueryField.fields]: (0, fields_1.zodFieldsQuery)(entityParamMapService),
        [json_api_nestjs_shared_1.QueryField.filter]: (0, filter_1.zodFilterQuery)(entityParamMapService),
        [json_api_nestjs_shared_1.QueryField.include]: (0, include_1.zodIncludeQuery)(entityParamMapService),
        [json_api_nestjs_shared_1.QueryField.sort]: (0, sort_1.zodSortQuery)(entityParamMapService),
        [json_api_nestjs_shared_1.QueryField.page]: (0, zod_share_1.zodPageInputQuery)(),
    };
}
function getZodResultSchema(shape) {
    return zod_1.z.object(shape).strict();
}
function zodQuery(entityParamMapService) {
    return getZodResultSchema(getShape(entityParamMapService));
}
function zodQueryOne(entityParamMapService) {
    return zod_1.z
        .object({
        [json_api_nestjs_shared_1.QueryField.fields]: (0, fields_1.zodFieldsQuery)(entityParamMapService),
        [json_api_nestjs_shared_1.QueryField.include]: (0, include_1.zodIncludeQuery)(entityParamMapService),
    })
        .strict();
}
//# sourceMappingURL=index.js.map