import { z } from 'zod';
import { EntityParam, EntityRelationProps } from '../../../../types';
import { EntityParamMapService } from '../../service';
declare function getZodSortRule(): z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>;
declare function getZodFieldRule<E extends object, IdKey extends string, PropsList extends ShapeArrayInput<E, IdKey>>(fields: PropsList, zodSchema: ZodSortRule): z.ZodOptional<z.ZodEffects<z.ZodObject<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }>, any>[k]; } : never, z.baseObjectInputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }>, any>[k]; } : never, z.baseObjectInputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<{ [K in PropsList[number] & PropertyKey]: z.ZodOptional<z.ZodEnum<["DESC", "ASC"]>>; }>[k_1]; } : never>>;
type ShapeArrayInput<E extends object, IdKey extends string> = EntityParam<E, IdKey>['props'] | EntityRelationProps<E, IdKey>[keyof EntityRelationProps<E, IdKey>];
type ZodSortRule = ReturnType<typeof getZodSortRule>;
type ZodFieldRule<E extends object, IdKey extends string, PropsList extends ShapeArrayInput<E, IdKey>> = ReturnType<typeof getZodFieldRule<E, IdKey, PropsList>>;
type ZodSortTarget<E extends object, IdKey extends string> = {
    target: ZodFieldRule<E, IdKey, EntityParam<E, IdKey>['props']>;
};
type ZodSortRelation<E extends object, IdKey extends string> = {
    [K in keyof EntityRelationProps<E, IdKey>]: ZodFieldRule<E, IdKey, EntityRelationProps<E, IdKey>[K]>;
};
type ZodSortShape<E extends object, IdKey extends string> = ZodSortTarget<E, IdKey> & ZodSortRelation<E, IdKey>;
export declare function zodSortQuery<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): z.ZodNullable<z.ZodEffects<z.ZodObject<ZodSortShape<E, IdKey> extends infer T extends z.ZodRawShape ? { [k in keyof T]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodSortShape<E, IdKey> extends infer T_3 extends z.ZodRawShape ? { [k in keyof T_3]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never>, any> extends infer T_1 ? { [k_1 in keyof T_1]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodSortShape<E, IdKey> extends infer T_2 extends z.ZodRawShape ? { [k in keyof T_2]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never>, any>[k_1]; } : never, z.baseObjectInputType<ZodSortShape<E, IdKey> extends infer T_6 extends z.ZodRawShape ? { [k in keyof T_6]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never> extends infer T_4 ? { [k_2 in keyof T_4]: z.baseObjectInputType<ZodSortShape<E, IdKey> extends infer T_5 extends z.ZodRawShape ? { [k in keyof T_5]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never>[k_2]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodSortShape<E, IdKey> extends infer T_9 extends z.ZodRawShape ? { [k in keyof T_9]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never>, any> extends infer T_7 ? { [k_1 in keyof T_7]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodSortShape<E, IdKey> extends infer T_8 extends z.ZodRawShape ? { [k in keyof T_8]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never>, any>[k_1]; } : never, z.baseObjectInputType<ZodSortShape<E, IdKey> extends infer T_12 extends z.ZodRawShape ? { [k in keyof T_12]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never> extends infer T_10 ? { [k_2 in keyof T_10]: z.baseObjectInputType<ZodSortShape<E, IdKey> extends infer T_11 extends z.ZodRawShape ? { [k in keyof T_11]: z.ZodOptional<ZodSortShape<E, IdKey>[k]>; } : never>[k_2]; } : never>>;
export type ZodSortQuery<E extends object, IdKey extends string> = ReturnType<typeof zodSortQuery<E, IdKey>>;
export type SortQuery<E extends object, IdKey extends string> = z.infer<ZodSortQuery<E, IdKey>>;
export {};
