"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodPageInputQuery = zodPageInputQuery;
const zod_1 = require("zod");
const constants_1 = require("../../../../constants");
function zodPageInputQuery() {
    return zod_1.z
        .object({
        size: zod_1.z
            .preprocess((x) => Number(x), zod_1.z.number().int().min(1))
            .default(constants_1.DEFAULT_PAGE_SIZE),
        number: zod_1.z
            .preprocess((x) => Number(x), zod_1.z.number().int().min(1))
            .default(constants_1.DEFAULT_QUERY_PAGE),
    })
        .strict()
        .default({
        size: constants_1.DEFAULT_PAGE_SIZE,
        number: constants_1.DEFAULT_QUERY_PAGE,
    });
}
//# sourceMappingURL=page.js.map