"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodRelationships = zodRelationships;
const zod_1 = require("zod");
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
const rel_data_1 = require("./rel-data");
const zod_utils_1 = require("../zod-utils");
function getZodResultData(typeName, primaryType, isNull, isPatch) {
    const dataScheme = zod_1.z.object({
        data: (0, zod_utils_1.setOptionalOrNot)((0, rel_data_1.zodRelData)(typeName, primaryType), isNull, isPatch),
    });
    return (0, zod_utils_1.setOptionalOrNot)(dataScheme.refine((0, zod_utils_1.nonEmptyObject)()), isNull, isPatch);
}
function getZodResultDataArray(typeName, primaryType) {
    return zod_1.z
        .object({
        data: (0, rel_data_1.zodRelData)(typeName, primaryType).array(),
    })
        .optional();
}
function zodRelationships(entityParamMapService, isPatch) {
    const shape = json_api_nestjs_shared_1.ObjectTyped.entries(entityParamMapService.entityParaMap.relationProperty).reduce((acum, [key, val]) => {
        const relEntityParaMap = entityParamMapService.getParamMap(val.entityClass);
        if (val.isArray) {
            acum[key] = getZodResultDataArray(relEntityParaMap.typeName, relEntityParaMap.primaryColumnType);
        }
        else {
            acum[key] = getZodResultData(relEntityParaMap.typeName, relEntityParaMap.primaryColumnType, val.nullable, isPatch);
        }
        return acum;
    }, {});
    return zod_1.z.object(shape).strict().refine((0, zod_utils_1.nonEmptyObject)());
}
//# sourceMappingURL=relationships.js.map