"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.prepareConfig = prepareConfig;
exports.getController = getController;
const common_1 = require("@nestjs/common");
const constants_1 = require("../constants");
function prepareConfig(moduleParams) {
    const options = moduleParams['options'] || {};
    return {
        connectionName: moduleParams['connectionName'] || constants_1.DEFAULT_CONNECTION_NAME,
        imports: moduleParams['imports'] || [],
        providers: moduleParams['providers'] || [],
        controllers: moduleParams['controllers'] || [],
        entities: moduleParams['entities'],
        options: {
            ...options,
            operationUrl: options['operationUrl'] || undefined,
            requiredSelectField: !!options['requiredSelectField'],
            debug: !!options['debug'],
            pipeForId: options['pipeForId'] || common_1.ParseIntPipe,
        },
    };
}
function getController(entity, controllers) {
    return controllers.find((item) => item && Reflect.getMetadata(constants_1.JSON_API_DECORATOR_ENTITY, item) === entity);
}
//# sourceMappingURL=module-helper.js.map